SystemOrganization addCategory: #'Smallchange-Test-Web'!
SystemOrganization addCategory: #'Smallchange-Test-Core'!
SystemOrganization addCategory: #'Smallchange-Test-Core-Commands'!

STTestCase subclass: #TestScwComponent
	instanceVariableNames: 'announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Web'!

!TestScwComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 18:43'!
invokeCallback: aSingleArgumentBlock
	self component block: aSingleArgumentBlock.
	(self lastResponse anchorWithLabel: 'Go') click.! !

!TestScwComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 19:02'!
setUp
	super setUp.
	self newApplicationWithRootClass: TestingScwComponent.
	self establishSession.
	announcer := Announcer new.
	self component announcer:  announcer.
	announcer on: ScwModalAnnouncement do: [ :a | | result | a result: (self component call: a component) ]! !

!TestScwComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 18:44'!
testCallModalOpensDialog
	self invokeCallback: [ : c | c callModal: WAFormDialog new].
	self assert: (self lastResponse 
		buttonWithValue: 'Ok') notNil! !

!TestScwComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 19:06'!
testCallModalReturnsValueOnAnswer
	| value |
	self invokeCallback: [ : c | value := c callModal: WAYesOrNoDialog new].
	(self lastResponse buttonWithValue: 'Yes') click.
	self assert: value ! !

TestCase subclass: #TestScAccount
	instanceVariableNames: 'profile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core'!

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/14/2012 16:03'!
newAccount
	^profile newAccount! !

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/14/2012 16:03'!
setUp
	profile := ScProfile name: 'test'.! !

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/14/2012 16:04'!
testTransactionWithAccountSetAppearsinAccountsTransactionList
	| account t |
	account := self newAccount.
	profile addAccount: account.
	t := profile newTransaction
			account: account.
	profile addTransaction: t.
	account transactions should include: t.! !

TestCase subclass: #TestScAccountsSufficientForBills
	instanceVariableNames: 'profile account analyser account2 income'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core'!

!TestScAccountsSufficientForBills methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/15/2012 18:07'!
expenseFor: anAmount
	^(ScExpense profile: profile) sourceAccount: account; amount: anAmount! !

!TestScAccountsSufficientForBills methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/18/2012 09:32'!
setUp
	profile := ScProfile name: 'Profile'.
	account := profile newAccount name: 'My Account'; openingBalance: 0; yourself.
	account2 := profile newAccount name: 'Account 2'; openingBalance: 0;yourself.
	
	profile addAccount: account.
	profile addAccount: account2.
	income := (profile newSchedule name: 'Pay Day'; interval: #month; count: 1; start: (Date today addDays: 10); 
		transaction: ((ScIncome profile: profile) account:  account; amount: 100)).
	profile addSchedule: income.
	analyser := ScAccountsSufficientForBills profile: profile.! !

!TestScAccountsSufficientForBills methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/15/2012 18:09'!
testBillAfterInsufficientPayday
	profile addSchedule: (profile newSchedule start: (Date tomorrow addDays: 11); interval: #month; count: 1; 
		transaction: (self expenseFor: 200)).
	analyser run.	
	self assert: analyser notices size equals: 1! !

!TestScAccountsSufficientForBills methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/15/2012 17:59'!
testBillAfterSufficientPayday
	profile addSchedule: (profile newSchedule start: (Date tomorrow addDays: 11); interval: #month; count: 1; 
		transaction: (self expenseFor: 100)).
	analyser run.	
	self assert: analyser notices isEmpty! !

!TestScAccountsSufficientForBills methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/18/2012 09:54'!
testBillAfterSufficientPaydayWithAutomaticTransfer
	profile addSchedule: ((profile newSchedule name: 'bill'; start: (Date tomorrow addDays: 11); interval: #month; count: 1; 
		transaction: ((self expenseFor: 100) sourceAccount: account2)) coveredBy: income).
	analyser run.	
	self assert: analyser notices isEmpty! !

!TestScAccountsSufficientForBills methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/15/2012 17:59'!
testBillBeforePayday
	profile addSchedule: (profile newSchedule start: (Date tomorrow); interval: #month; count: 1; 
		transaction: (self expenseFor: 200)).
	analyser run.	
	self assert: analyser notices notEmpty! !

!TestScAccountsSufficientForBills methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/15/2012 18:00'!
testCantPayEitherBill
	profile addSchedule: (profile newSchedule name: 's1'; start: (Date tomorrow addDays: 11); interval: #month; count: 1; 
		transaction: (self expenseFor: 200)).
	profile addSchedule: (profile newSchedule name: 's2'; start: (Date tomorrow addDays: 12); interval: #month; count: 1; 
		transaction: (self expenseFor: 200)).
	analyser run.	
	self assert: analyser notices size equals: 2! !

!TestScAccountsSufficientForBills methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/15/2012 18:00'!
testCantPaySecondBill
	profile addSchedule: (profile newSchedule name: 's1'; start: (Date tomorrow addDays: 11); interval: #month; count: 1; 
		transaction: (self expenseFor: 100)).
	profile addSchedule: (profile newSchedule name: 's2'; start: (Date tomorrow addDays: 12); interval: #month; count: 1; 
		transaction: (self expenseFor: 100)).
	analyser run.	
	self assert: analyser notices size equals: 1! !

!TestScAccountsSufficientForBills methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/15/2012 17:54'!
testNoBillsMeansNoWarnings
	analyser run.
	self assert: analyser notices isEmpty! !

TestScAccountsSufficientForBills subclass: #TestScPoolsSufficientForBills
	instanceVariableNames: 'pool pool2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core'!

!TestScPoolsSufficientForBills methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/15/2012 18:06'!
expenseFor: anAmount
	^(ScExpense profile: profile) sourceAccount: account; sourcePool: pool; amount: anAmount! !

!TestScPoolsSufficientForBills methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/18/2012 10:07'!
setUp
	profile := ScProfile name: 'Profile'.
	account := profile newAccount name: 'My Account'; openingBalance: 0; yourself.
	profile addAccount: account.
	pool := profile newPool name: 'A Pool'; defaultAccount: account;yourself.
	pool2 := profile newPool name: 'Pool 2'; defaultAccount: account;yourself.
	profile addPool: pool.
	profile addPool: pool2.
	income := (profile newSchedule name: 'Pay Day'; interval: #month; count: 1; start: (Date today addDays: 10); 
		transaction: ((ScIncome profile: profile) pool: pool; account: account; amount: 100)).
	profile addSchedule: income.
	analyser := ScPoolsSufficientForBills profile: profile.! !

!TestScPoolsSufficientForBills methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/18/2012 10:08'!
testBillAfterSufficientPaydayWithAutomaticTransfer
	profile addSchedule: ((profile newSchedule name: 'A Bill'; start: (Date tomorrow addDays: 11); interval: #month; count: 1; 
		transaction: ((self expenseFor: 100) sourcePool: pool2)) coveredBy: income).
	analyser run.	
	self assert: analyser notices isEmpty! !

TestCase subclass: #TestScAddAccount
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core-Commands'!

!TestScAddAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 20:25'!
testAddAccountAddsToProfile
	[ :profile :account | [ (ScAddAccount profile: profile account: account) do ] 
		should strictly satisfy: [ profile addAccount: account ]] runScenario
! !

!TestScAddAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 20:25'!
testUndoAddAccountRemovesFromProfile
	[ :profile :account |  |  command | 
		command := (ScAddAccount profile: profile account: account).
		[ command undo] 
			should strictly satisfy: [ profile removeAccount: account ]] runScenario! !

TestCase subclass: #TestScAddPool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core-Commands'!

!TestScAddPool methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 20:18'!
testAddPoolAddsToProfile
	[ :profile :pool | [ (ScAddPool profile: profile pool: pool) do ] 
		should strictly satisfy: [ profile addPool: pool ]] runScenario
! !

!TestScAddPool methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 20:19'!
testUndoAddPoolRemovesFromProfile
	[ :profile :pool |  |  command | 
		command := (ScAddPool profile: profile pool: pool).
		[ command undo] 
			should strictly satisfy: [ profile removePool: pool ]] runScenario! !

TestCase subclass: #TestScAddScedule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core-Commands'!

!TestScAddScedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/4/2012 17:17'!
testAddScheduleAddsToProfile
	[ :profile :schedule | [ (ScAddSchedule profile: profile schedule: schedule) do ] 
		should strictly satisfy: [ profile addSchedule: schedule ]] runScenario
! !

!TestScAddScedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/4/2012 17:13'!
testUndoAddScheduleRemovesFromProfile
	[ :profile :schedule |  |  command | 
		command := (ScAddSchedule profile: profile schedule: schedule).
		[ command undo] 
			should strictly satisfy: [ profile removeSchedule: schedule ]] runScenario! !

TestCase subclass: #TestScAutomaticAllocations
	instanceVariableNames: 'profile account1 account2 pool1 pool2 income'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core'!

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 14:59'!
newBillEvery: anInterval by: aNumber
	^(profile newSchedule)
		name: 'bill';
		start: (Date tomorrow);
		interval: anInterval;
		count: aNumber;
		transaction: (self newExpense);
		yourself.
! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 15:05'!
newExpense
	^(ScExpense profile: profile)
		sourcePool: pool2;
		sourceAccount: account2;
		amount: 100! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 14:32'!
setUp
	profile := ScProfile name: 'profile'.
	account1 := profile newAccount 
		name: 'account1';
		openingBalance: 0.
	account2 := profile newAccount
		name: 'account2';
		openingBalance: 0.
	profile 
		addAccount: account1;
		addAccount: account2.
		
	pool1 := profile newPool
		name: 'pool1';
		defaultAccount: account1.
	pool2 := profile newPool
		name: 'pool2';
		defaultAccount: account2.
	profile
		addPool: pool1;
		addPool: pool2.
	income := profile newSchedule
		start: Date tomorrow;
		interval: #week;
		count: 2;
		transaction: ((ScIncome profile: profile)	account: account1; amount: 100).
	profile addSchedule: income.! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/18/2012 13:57'!
testAutomaticAllocationCreatesBothAllocationAndTransfer
	| bill |
	bill := self newBillEvery: income interval by: income count.
	profile addSchedule: bill.
	bill coveredBy: income.
	self assert: income automaticTransactions size equals: 2! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/18/2012 15:08'!
testAutomaticAllocationDoesntCreateUnnecessaryAllocation
	| bill |
	bill := self newBillEvery: income interval by: income count.
	bill transaction sourcePool: nil.
	profile addSchedule: bill.
	bill coveredBy: income.
	self assert: income automaticTransactions size equals: 1! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/18/2012 15:04'!
testAutomaticAllocationDoesntCreateUnnecessaryTransfer
	| bill |
	bill := self newBillEvery: income interval by: income count.
	bill transaction sourceAccount: account1.
	profile addSchedule: bill.
	bill coveredBy: income.
	self assert: income automaticTransactions size equals: 1! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/18/2012 14:28'!
testAutomaticAllocationHasCorrectDestinationAccount
	| bill |
	bill := self newBillEvery: income interval by: income count.
	profile addSchedule: bill.
	bill coveredBy: income.
	income automaticTransactions second account 
		should be: bill transaction sourceAccount! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 15:06'!
testAutomaticAllocationHasCorrectDestinationPool
	| bill |
	bill := self newBillEvery: income interval by: income count.
	profile addSchedule: bill.
	bill coveredBy: income.
	income automaticTransactions first pool 
		should be: bill transaction sourcePool! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/18/2012 14:28'!
testAutomaticAllocationHasCorrectSourceAccount
	| bill |
	bill := self newBillEvery: income interval by: income count.
	profile addSchedule: bill.
	bill coveredBy: income.
	income automaticTransactions second sourceAccount should be: income transaction account! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 15:04'!
testAutomaticAllocationHasCorrectSourcePool
	| bill |
	bill := self newBillEvery: income interval by: income count.
	profile addSchedule: bill.
	bill coveredBy: income.
	income automaticTransactions first sourcePool should be: income transaction pool! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 15:01'!
testBillWithSameTimetableIsAllocatedCompletely
	| bill |
	bill := self newBillEvery: income interval by: income count.
	profile addSchedule: bill.
	bill coveredBy: income.
	income automaticTransactions first amount should be: bill transaction amount.! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/18/2012 15:01'!
testCoveringABillCreatesAnAutomaticTransaction
	| bill |
	bill := self newBillEvery: #week by: 2.
	profile addSchedule: bill.
	bill coveredBy: income.
	self assert: income automaticTransactions notEmpty! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/18/2012 14:27'!
testFirstAutomaticAllocationIsNotTransfer
	| bill |
	bill := self newBillEvery: income interval by: income count.
	profile addSchedule: bill.
	bill coveredBy: income.
	self deny: income automaticTransactions first isTransfer! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/18/2012 13:56'!
testFirstAutomaticAllocationIsPoolAllocation
	| bill |
	bill := self newBillEvery: income interval by: income count.
	profile addSchedule: bill.
	bill coveredBy: income.
	self assert: income automaticTransactions first isAllocation! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 17:54'!
testFortnightlyBillWeeklyPay
	| bill |
	income interval: #week; count: 1.
	bill := self newBillEvery: #week by: 2.
	profile addSchedule: bill.
	bill coveredBy: income.
	self assert: income automaticTransactions first amount equals: (bill transaction amount / 2).! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/18/2012 15:33'!
testFortnightlyBillWeeklyPayWithInsufficientPay
	| bill |
	income interval: #week; count: 1.
	bill := self newBillEvery: #week by: 2.
	bill transaction amount: 300.
	profile addSchedule: bill.
	bill coveredBy: income.
	self assert: income automaticTransactions first amount equals: (bill transaction amount / 2). "Allocate the same amount, even though it's not enough"! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 14:57'!
testIncomeCoveringNoBillsHasNoAutomaticTransactions
	income automaticTransactions size should be: 0! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/18/2012 10:34'!
testMonthlyBillWeeklyPay
	| bill expected |
	income interval: #week; count: 1.
	bill := self newBillEvery: #month by: 1.
	profile addSchedule: bill.
	bill coveredBy: income.
	expected := ((bill transaction amount / ((1461/4) / 12)) * 7) roundTo: (1/100). " (Amount / days in a month - averaged over four years) multipled by days in a week.  Then round to nearest cent"
	self assert: income automaticTransactions first amount equals: expected.! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/18/2012 13:57'!
testSecondAutomaticAllocationIsNotAllocation
	| bill |
	bill := self newBillEvery: income interval by: income count.
	profile addSchedule: bill.
	bill coveredBy: income.
	self deny: income automaticTransactions second isAllocation! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/18/2012 13:56'!
testSecondAutomaticAllocationIsTransfer
	| bill |
	bill := self newBillEvery: income interval by: income count.
	profile addSchedule: bill.
	bill coveredBy: income.
	self assert: income automaticTransactions second isTransfer! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/18/2012 15:40'!
testWeeklyBillFortnightlyPay
	| bill |
	income interval: #week; count: 2.
	bill := self newBillEvery: #week by: 1.
	bill transaction amount: 20.
	profile addSchedule: bill.
	bill coveredBy: income.
	self assert: income automaticTransactions first amount equals: bill transaction amount * 2.! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/18/2012 15:40'!
testWeeklyBillFortnightlyPayWithInsufficientPay
	| bill |
	income interval: #week; count: 2.
	bill := self newBillEvery: #week by: 1.
	profile addSchedule: bill.
	bill coveredBy: income.
	self assert: income automaticTransactions first amount equals: bill transaction amount * 2! !

TestCase subclass: #TestScCommands
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core'!

!TestScCommands methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 14:18'!
testScAddAccount
	[ :profile :account | | command |
		[ ( ScAddAccount profile: profile account: account) do]  should strictly satisfy: [
			profile addAccount: account ] ] runScenario! !

!TestScCommands methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 14:02'!
testScAddPool
	[ :profile :pool | 
		[ (ScAddPool profile: profile pool: pool) do]  should strictly satisfy: [
			profile addPool: pool ] ] runScenario! !

!TestScCommands methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 15:48'!
testUndoScAddAccount
	[ :profile :account | | command |
		command := ScAddAccount profile: profile account: account.
		 [command undo ]  should strictly satisfy: [
			profile removeAccount: account ] ] runScenario! !

!TestScCommands methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 15:49'!
testUndoScAddPool
	[ :profile :pool | | command |
		command := ScAddPool profile: profile pool: pool.
		[command undo ]  should strictly satisfy: [
			profile removePool: pool ] ] runScenario! !

TestCase subclass: #TestScPool
	instanceVariableNames: 'profile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core'!

!TestScPool methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/14/2012 15:59'!
newPool
	^profile newPool! !

!TestScPool methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/7/2012 21:49'!
setUp
	profile := ScProfile name: 'test'.
	profile addAccount: (ScAccount new name: 'account'; yourself).! !

!TestScPool methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/7/2012 21:49'!
testDefaultAccountMustExistInProfile
	[self newPool defaultAccount: ScAccount new ] 
		should raise: MbValidationError! !

!TestScPool methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/14/2012 16:02'!
testTransactionWithPoolSetAppearsinPoolsTransactionList
	| pool t |
	pool := self newPool.
	profile addPool: pool.
	t := profile newTransaction
			pool: pool.
	profile addTransaction: t.
	pool transactions should include: t.! !

TestCase subclass: #TestScProfile
	instanceVariableNames: 'profile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core'!

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/18/2012 20:44'!
setUp
	profile := ScProfile name: 'test'! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 14:16'!
testAddAccount
	[ :account | 
		profile addAccount: account ] runScenario.
	self assert: profile accounts size equals: 1

! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/18/2012 21:19'!
testAddAccountWithSameNameFails
	profile addAccount: (ScAccount new name: 'foo'; yourself).
	self should: [ profile addAccount: (ScAccount new name: 'foo'; yourself)] raise: MbValidationError! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 14:10'!
testAddPool
	[ :pool | 
		profile addPool: pool ] runScenario.
	self assert: profile pools size equals: 1! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/18/2012 21:19'!
testAddPoolWithSameNameFails
	profile addPool: (ScPool new name: 'foo'; yourself).
	self should: [ profile addPool: (ScPool new name: 'foo'; yourself)] raise: MbValidationError! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/4/2012 16:55'!
testAddScedule
	[ :schedule | 
		profile addSchedule: schedule ] runScenario.
	self assert: profile schedules size equals: 1! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/4/2012 16:58'!
testAddScheduleWithSameNameFails
	profile addSchedule: (ScSchedule new name: 'foo'; yourself).
	self should: [ profile addSchedule: (ScSchedule new name: 'foo'; yourself)] raise: MbValidationError! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/10/2012 08:41'!
testLastCheckpointIsTodayForNewInstances
	self assert: profile checkpointDate equals: Date today! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/4/2012 17:02'!
testNewSchedule
	self assert: (profile newSchedule instVarNamed: #profile) equals: profile! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/10/2012 08:43'!
testPendingIsEmptyForNewInstance
	self assert: profile pendingTransactions isEmpty! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 14:16'!
testRemoveAccount
	[ :account | 
		profile addAccount: account.
		profile removeAccount: account ] runScenario.
	self assert: profile accounts isEmpty

! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 14:16'!
testRemovePool
	[:pool |
		profile addPool: pool.
		profile removePool: pool] runScenario.
	self assert: profile pools isEmpty

! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/4/2012 16:59'!
testRemoveSchedule
	[ :schedule | 
		profile addSchedule: schedule.
		profile removeSchedule: schedule ] runScenario.
	self assert: profile schedules isEmpty

! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/10/2012 08:58'!
testUpdatePendingPopulatesPendingTransactions
	profile addSchedule: (profile newSchedule
			start: Date yesterday;
			interval: #month;
			count: 1;
			transaction: (ScIncome new)).
	profile instVarNamed: #checkpoint put: (Date today subtractDays: 7).
	profile updatePending.
	self assert: profile pendingTransactions size equals: 1! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/10/2012 08:42'!
testUpdatePendingUpdatesCheckpointDate
	profile instVarNamed: #checkpoint put: Date yesterday.
	profile updatePending.
	self assert: profile checkpointDate equals: Date today.! !

TestCase subclass: #TestScRecordTransaction
	instanceVariableNames: 'profile account pool transaction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core-Commands'!

!TestScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:28'!
setUp
	profile := ScProfile name: 'Test'.
	account :=  profile newAccount.
	pool := profile newPool.
	profile addAccount: account.
	profile addPool: pool.
	transaction := profile newTransaction
		account: account;
		pool: pool;
		amount: 12.34;
		yourself! !

!TestScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:52'!
testRecordTransactionAddsToAccount
	(ScRecordTransaction profile: profile transaction: transaction) do.
	account transactions should include: transaction.! !

!TestScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:52'!
testRecordTransactionAddsToPool
	(ScRecordTransaction profile: profile transaction: transaction) do.
	pool transactions should include: transaction.! !

!TestScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:40'!
testRecordTransactionAddsToProfile
	[ :p | [ (ScRecordTransaction profile: p transaction: transaction) do ] 
		should strictly satisfy: [ p addTransaction: transaction ]] runScenario
! !

!TestScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:55'!
testRecordTransactionWithNoPoolSucceeds
	transaction pool: nil.
	(ScRecordTransaction profile: profile transaction: transaction) do.
! !

!TestScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:53'!
testUndoRecordTransactionRemovesFromAccount
	(ScRecordTransaction profile: profile transaction: transaction) do; undo.
	account transactions shouldnt include: transaction.! !

!TestScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:53'!
testUndoRecordTransactionRemovesFromPool
	(ScRecordTransaction profile: profile transaction: transaction) do; undo.
	pool transactions shouldnt include: transaction.! !

!TestScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/14/2012 16:09'!
testUndoRecordTransactionRemovesFromProfile
	[ :p |  |  command | 
		command := (ScRecordTransaction profile: p transaction: transaction).
		[ command undo] 
			should strictly satisfy: [ p removeTransaction: transaction ]] runScenario! !

TestCase subclass: #TestScSchedule
	instanceVariableNames: 'profile account1 account2 pool1 pool2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core'!

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 13:51'!
newAllocation
	^(ScTransaction profile: profile)
		pool: pool1;
		account: account1;
		sourceAccount: account1! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 13:31'!
newExpense
	^ScExpense profile: profile! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 13:31'!
newIncome
	^ScIncome profile: profile! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 13:41'!
newTransfer
	^(ScTransaction profile: profile)
		sourceAccount: account1;
		account: account2! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 13:30'!
setUp
	profile := ScProfile name: 'profile'.
	account1 := profile newAccount 
		name: 'account1';
		openingBalance: 0.
	account2 := profile newAccount
		name: 'account2';
		openingBalance: 0.
	profile 
		addAccount: account1;
		addAccount: account2.
		
	pool1 := profile newPool
		name: 'pool1';
		defaultAccount: account1.
	pool2 := profile newPool
		name: 'pool2';
		defaultAccount: account2.
	profile
		addPool: pool1;
		addPool: pool2.! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 13:30'!
testAnnually
	| schedule transactions |
	schedule := (profile newSchedule)
		start: (Date year: 2012 month: 1 day: 14);
		interval: #year;
		count: #1;
		transaction: (self newIncome).
	self assert: (schedule nextAfter: (Date year: 2012 month: 5 day: 6)) equals: (Date year: 2013 month: 1 day: 14)! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 13:31'!
testBiannually
	| schedule transactions |
	schedule := (profile newSchedule)
		start: (Date year: 2012 month: 1 day: 14);
		interval: #year;
		count: #2;
		transaction: (self newIncome).
	self assert: (schedule nextAfter: (Date year: 2012 month: 5 day: 6)) equals: (Date year: 2014 month: 1 day: 14)! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 14:35'!
testBillCanBeCoveredByIncome
	| s1 s2 |
	s1 := profile newSchedule
		name: 'bill';
		transaction: self newExpense.
	profile addSchedule: s1.
	s2 := profile newSchedule
		name: 'income';
		transaction: self newIncome.
	profile addSchedule: s2.
	[ s1 coveredBy: s2 ] shouldnt raise: MbValidationError! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 14:35'!
testBillCantBeCoveredByAllocation
	| s1 s2 |
	s1 := (profile newSchedule)
		name: 'bill';
		transaction: self newExpense.
	profile addSchedule: s1.
	s2 := (profile newSchedule)
		name: 'bill2';
		transaction: self newExpense.
	profile addSchedule: s2.
	[ s1 coveredBy: s2 ] should raise: MbValidationError! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 14:35'!
testBillCantBeCoveredByOtherBill
	| s1 s2 |
	s1 := profile newSchedule
		name: 'bill';
		transaction: self newExpense.
	profile addSchedule: s1.
	s2 := profile newSchedule
		name: 'bill2';
		transaction: self newExpense.
	profile addSchedule: s2.
	[ s1 coveredBy: s2 ] should raise: MbValidationError! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 14:38'!
testBillsCovered
	| s1 s2 |
	s1 := profile newSchedule
		name: 'bill';
		transaction: self newExpense.
	profile addSchedule: s1.
	s2 := profile newSchedule
		name: 'income';
		transaction: self newIncome.
	profile addSchedule: s2.
	s1 coveredBy: s2.
	s2 billsCovered should include: s1! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 13:33'!
testDaily
	| schedule transactions |
	schedule := (profile newSchedule)
		start: (Date year: 2012 month: 1 day: 14);
		interval: #day;
		count: #1;
		transaction: (self newIncome).
	self assert: (schedule nextAfter: (Date year: 2012 month: 5 day: 6)) equals: (Date year: 2012 month: 5 day: 7)! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 13:33'!
testFortnightly
	| schedule transactions |
	schedule := (profile newSchedule)
		start: (Date year: 2012 month: 1 day: 14);
		interval: #week;
		count: #2;
		transaction: (self newIncome).
	self assert: (schedule nextAfter: (Date year: 2012 month: 5 day: 6)) equals: (Date year: 2012 month: 5 day: 19)! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 13:26'!
testIncomeCantBeCovered
	| s1 s2 p |
	s1 := (ScSchedule profile: p)
		transaction: (self newIncome).
	s2 := (ScSchedule profile: p).
	[ s1 coveredBy: s2 ] should raise: MbValidationError! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 13:40'!
testIsAllocation
	| schedule transactions |
	schedule := (profile newSchedule)
		transaction: (self newAllocation).
	self assert: schedule isAllocation! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 13:40'!
testIsExpense
	| schedule transactions |
	schedule := (profile newSchedule)
		transaction: (self newExpense).
	self assert: schedule isExpense! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 13:40'!
testIsIncome
	| schedule transactions |
	schedule := (profile newSchedule)
		transaction: (self newIncome).
	self assert: schedule isIncome! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 13:41'!
testIsTransfer
	| schedule transactions |
	schedule := (profile newSchedule)
		transaction: (self newTransfer).
	self assert: schedule isTransfer! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 13:34'!
testMonthly
	| schedule transactions |
	schedule := (profile newSchedule)
		start: (Date year: 2012 month: 1 day: 14);
		interval: #month;
		count: #1;
		transaction: (self newIncome).
	self assert: (schedule nextAfter: (Date year: 2012 month: 5 day: 6)) equals: (Date year: 2012 month: 5 day: 14)! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 14:40'!
testNoBillsCovered
	| s1 |
	s1 := profile newSchedule
		name: 'income';
		transaction: self newIncome.
	profile addSchedule: s1.
	s1 billsCovered isEmpty should be: true.! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 13:34'!
testQuarterly
	| schedule transactions |
	schedule := (profile newSchedule)
		start: (Date year: 2012 month: 1 day: 14);
		interval: #month;
		count: #3;
		transaction: (self newIncome).
	self assert: (schedule nextAfter: (Date year: 2012 month: 5 day: 6)) equals: (Date year: 2012 month: 7 day: 14)! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 13:34'!
testTransactionsBetween
	| schedule transactions |
	schedule := (profile newSchedule)
		start: (Date year: 2012 month: 1 day: 14);
		interval: #month;
		count: #1;
		transaction: (self newIncome).
		
	transactions := schedule transactionsBetween: (Date year: 2012 month: 2 day: 1) and: (Date year: 2012 month: 2 day: 20).
	self assert: transactions size equals: 1.
	self assert: transactions first date equals: (Date year: 2012 month: 2 day: 14)! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 13:34'!
testWeekly
	| schedule transactions |
	schedule := (profile newSchedule)
		start: (Date year: 2012 month: 1 day: 14);
		interval: #week;
		count: #1;
		transaction: (self newIncome).
	self assert: (schedule nextAfter: (Date year: 2012 month: 5 day: 6)) equals: (Date year: 2012 month: 5 day: 12)! !

TestCase subclass: #TestScTimetable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core'!

!TestScTimetable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 17:46'!
testDailyToWeeklyRatio
	self assert: (ScDaily new ratioFor: ScWeekly new) equals: 7! !

!TestScTimetable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 17:52'!
testFortnightlyToMonthlyRatio
	self assert: ((ScWeekly every: 2) ratioFor: (ScMonthly new)) equals: (487/224)! !

!TestScTimetable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 18:04'!
testMonthlyToFortnightlyRatio
	self assert: (ScMonthly new ratioFor: (ScWeekly every: 2)) equals: (224/487)! !

!TestScTimetable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 17:50'!
testMonthlyToWeeklyRatio
	self assert: (ScMonthly new ratioFor: (ScWeekly new)) equals: (112/487)! !

!TestScTimetable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 17:47'!
testWeeklyToFortnightlyRatio
	self assert: (ScWeekly new ratioFor: (ScWeekly every: 2)) equals: 2! !

!TestScTimetable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 17:50'!
testWeeklyToMonthlyRatio
	self assert: (ScWeekly new ratioFor: (ScMonthly new)) equals: (487/112)! !

TestCase subclass: #TestScTransaction
	instanceVariableNames: 'profile a1 p1 p2 a2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core'!

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:35'!
newTransaction
	^profile newTransaction! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/25/2012 13:54'!
setUp
	profile := ScProfile name: 'test'.
	a1 := (ScAccount new name: 'account'; yourself).
	a2 := (ScAccount new name: 'account2'; yourself).
	p1 := (ScPool new name: 'pool'; yourself).
	p2 := (ScPool new name: 'pool2'; yourself).
	profile addAccount: a1.
	profile addAccount: a2.
	profile addPool: p1.
	profile addPool: p2.! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:23'!
testTransactionAccountMustExistInProfile
	[self newTransaction account: ScAccount new ] 
		should raise: MbValidationError! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:23'!
testTransactionAccountMustExistInProfileSuccess
	[self newTransaction account: profile accounts first ] 
		should not raise: MbValidationError! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:23'!
testTransactionCanHaveNoPool
	[ self newTransaction pool: nil ] 
		should not raise: MbValidationError! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:23'!
testTransactionMustHaveAccount
	[ self newTransaction account: nil ] 
		should raise: MbRequiredFieldError! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:30'!
testTransactionPoolMustExistInProfile
	[ self newTransaction pool: ScPool new ]  
		should raise: MbValidationError! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:23'!
testTransactionPoolMustExistInProfileSuccess
	[ self newTransaction pool: profile pools first ] 
		should not raise: MbValidationError! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/25/2012 13:57'!
testTransactionWithBothSourceAndDestinationAccountIsNotExpense
	| t| 
	t := self newTransaction.
	t account: a1.
	t sourceAccount: a2.
	t isExpense should be: false! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/25/2012 13:56'!
testTransactionWithBothSourceAndDestinationAccountIsNotIncome
	| t| 
	t := self newTransaction.
	t account: a1.
	t sourceAccount: a2.
	t isIncome should be: false! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/25/2012 13:54'!
testTransactionWithBothSourceAndDestinationAccountIsTransfer
	| t| 
	t := self newTransaction.
	t account: a1.
	t sourceAccount: a2.
	t isTransfer should be: true! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/25/2012 14:06'!
testTransactionWithDifferentSourceAndDestinationAccountAndPoolIsAllocation
	| t| 
	t := self newTransaction.
	t account: a1.
	t sourceAccount: a2.
	t pool: p1.
	t sourcePool: p2.
	t isAllocation should be: true! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/25/2012 14:06'!
testTransactionWithDifferentSourceAndDestinationAccountAndPoolIsTransfer
	| t| 
	t := self newTransaction.
	t account: a1.
	t sourceAccount: a2.
	t pool: p1.
	t sourcePool: p2.
	t isAllocation should be: true! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/25/2012 14:05'!
testTransactionWithDifferentSourceAndDestinationPoolIsAllocation
	| t| 
	t := self newTransaction.
	t account: a1.
	t sourceAccount: a1.
	t pool: p1.
	t sourcePool: p2.
	t isAllocation should be: true! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/25/2012 13:55'!
testTransactionWithOnlyDestinationAccountIsIncome
	| t| 
	t := self newTransaction.
	t account: a1.
	t isIncome should be: true.! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 13:47'!
testTransactionWithOnlyDestinationAccountIsNotExpense
	| t| 
	t := self newTransaction.
	t account: a1.
	t isExpense should be: false! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/25/2012 13:55'!
testTransactionWithOnlyDestinationAccountIsNotTransfer
	| t| 
	t := self newTransaction.
	t account: a1.
	t isTransfer should be: false! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/18/2012 14:37'!
testTransactionWithOnlyDestinationPoolIsAllocation
	| t| 
	t := self newTransaction.
	t pool: p1.
	self assert: t isAllocation ! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/25/2012 13:56'!
testTransactionWithOnlySourceAccountIsExpense
	| t| 
	t := self newTransaction.
	t sourceAccount: a1.
	t isExpense should be: true! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/25/2012 13:56'!
testTransactionWithOnlySourceAccountIsNotIncome
	| t| 
	t := self newTransaction.
	t sourceAccount: a1.
	t isIncome should be: false! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/25/2012 13:55'!
testTransactionWithOnlySourceAccountIsNotTransfer
	| t| 
	t := self newTransaction.
	t sourceAccount: a1.
	t isTransfer should be: false! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/18/2012 14:55'!
testTransactionWithOnlySourcePoolIsAllocation
	| t| 
	t := self newTransaction.
	t sourcePool: p1.
	t account: a1.
	t sourceAccount: a1.	
	t isAllocation should be: true.! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/25/2012 14:04'!
testTransactionWithSameSourceAndDestinationAccountIsNotTransfer
	| t| 
	t := self newTransaction.
	t account: a1.
	t sourceAccount: a1.
	t pool: p1.
	t isTransfer should be: false! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/18/2012 15:01'!
testTransactionWithSameSourceAndDestinationPoolIsNotAllocation
	| t| 
	t := self newTransaction.
	t pool: p1.
	t sourcePool: p1.
	self deny: t isAllocation! !

TestCase subclass: #TestScUnallocated
	instanceVariableNames: 'profile a p unallocated'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core'!

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 17:06'!
newExpense
	^(ScExpense profile: profile)
		sourceAccount: a;
		amount: 1;
		yourself! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 17:06'!
newIncome
	^(ScIncome profile: profile)
		account: a;
		amount: 1;		
		yourself! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 17:06'!
newTransaction
	^(ScTransaction profile: profile)
		sourceAccount: a;
		account: a;
		amount: 1;
		yourself! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 16:33'!
setUp
	profile := ScProfile name: 'test'.
	a := (ScAccount new name: 'account'; yourself).
	p := (ScPool new name: 'pool'; yourself).
	profile addAccount: a.
	profile addPool: p.
	unallocated := profile unallocated.! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 17:10'!
testAccumulateExpenseWithNoSourcePoolIsNegative
	| t |
	t := self newExpense.
	self assert: (unallocated accumulate: t) equals: -1! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 17:07'!
testAccumulateExpenseWithSourcePoolIsZero
	| t |
	t := self newExpense
			sourcePool: p.
	self assert: (unallocated accumulate: t) equals: 0! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 17:10'!
testAccumulateIncomeWithNoPoolIsPositive
	| t |
	t := self newIncome.
	self assert: (unallocated accumulate: t) equals: 1! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 17:08'!
testAccumulateIncomeWithPoolIsZero
	| t |
	t := self newIncome
			pool: p.
	self assert: (unallocated accumulate: t) equals: 0! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 17:08'!
testAccumulateTransactionWithBothPoolsIsZero
	| t |
	t := self newTransaction
		sourcePool: p;
		pool: p.
	self assert: (unallocated accumulate: t) equals: 0! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 17:11'!
testAccumulateTransactionWithNoPoolIsPositive
	| t |
	t := self newTransaction
		sourcePool: p.
	self assert: (unallocated accumulate: t) equals: 1! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 17:09'!
testAccumulateTransactionWithNoPoolsAtAllIsZero
	| t |
	t := self newTransaction.
	self assert: (unallocated accumulate: t) equals: 0! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 17:11'!
testAccumulateTransactionWithNoSourcePoolIsNegative
	| t |
	t := self newTransaction
		pool: p.
	self assert: (unallocated accumulate: t) equals: -1! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 16:40'!
testUnallocatedDoesntOwnExpenseWithSourcePool
	| t |
	t := self newExpense
			sourcePool: p.
	self deny: (unallocated ownsTransaction: t)! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 16:39'!
testUnallocatedDoesntOwnIncomeWithPool
	| t |
	t := self newIncome
			pool: p.
	self deny: (unallocated ownsTransaction: t)! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 16:41'!
testUnallocatedDoesntOwnTransactionWithBothPools
	| t |
	t := self newTransaction
		sourcePool: p;
		pool: p.
	self deny: (unallocated ownsTransaction: t)! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 16:40'!
testUnallocatedDoesntOwnTransactionWithNoPoolsAtAll
	| t |
	t := self newTransaction.
	self deny: (unallocated ownsTransaction: t)! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 16:39'!
testUnallocatedOwnsExpenseWithNoSourcePool
	| t |
	t := self newExpense.
	self assert: (unallocated ownsTransaction: t)! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 16:39'!
testUnallocatedOwnsIncomeWithNoPool
	| t |
	t := self newIncome.
	self assert: (unallocated ownsTransaction: t)! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 16:47'!
testUnallocatedOwnsTransactionWithNoPool
	| t |
	t := self newTransaction
		sourcePool: p.
	self assert: (unallocated ownsTransaction: t)! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 16:49'!
testUnallocatedOwnsTransactionWithNoSourcePool
	| t |
	t := self newTransaction
		pool: p.
	self assert: (unallocated ownsTransaction: t)! !

WAComponent subclass: #ModalDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Web'!

!ModalDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/26/2012 19:53'!
renderContentOn: html
	html paragraph: 'Hello!!'.
	html anchor callback: [self answer: 42]; with: 'Close'! !

WAComponent subclass: #ModalTest
	instanceVariableNames: 'answer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Web'!

!ModalTest class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/26/2012 19:52'!
canBeRoot
	^true! !

!ModalTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/26/2012 19:55'!
callModal: aDialog
	^self call: aDialog! !

!ModalTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/26/2012 20:30'!
renderContentOn: html
	html container: [
		html paragraph: [
		html anchor callback: [answer := self callModal: ModalDialog new]; with: 'Open Dialog'].
		html paragraph: [
			html anchor 
				attributeAt: 'data-toggle' put: 'modal'; 
				attributeAt: 'data-backdrop' put: 'false';
				url: '#xxx'; with: 'Open Modal'.].

		answer ifNotNil: [html heading level: 1; with: answer].
		
	html div class: 'modal'; class: 'hide'; id: 'xxx'; with: 'Foo'].
	html script: ((html jQuery id: 'xxx') call: 'on' with: 'show' with: ((html jQuery id: 'xxx') load html: [ :h | h render: ModalDialog new ] ) asFunction)! !

ScwComponent subclass: #TestingScwComponent
	instanceVariableNames: 'block announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Web'!

!TestingScwComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 18:53'!
announcer
	^announcer! !

!TestingScwComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 18:53'!
announcer: anAnnouncer
	announcer := anAnnouncer.! !

!TestingScwComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 18:39'!
block: aBlock
	block := aBlock! !

!TestingScwComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 18:42'!
renderContentOn: html
	html anchor callback: [ block value: self ]; with: 'Go'! !
